/*
 * Copyright (c) 2008-2014 Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext,NX,Sonatype,Nexus*/
NX.define('Nexus.ssl.certificate.AddCertificateView', {
  extend : 'Ext.Window',

  xtype : 'add-certificate-window',

  title : 'Add certificate',
  width : 550,
  height : 450,
  layout : 'fit',
  onEsc : function() {
    this.close();
  },

  initComponent : function() {
    var self = this;

    self.items = [
      {
        xtype : 'certificate-details',
        certificate : self.certificate
      }
    ];

    self.buttons = [
      {
        xtype : 'button',
        text : 'Add Certificate',
        handler : function() {
          self.addCertificate(self.certificate.pem);
        }
      }
    ];

    self.constructor.superclass.initComponent.apply(self, arguments);
  },

  /**
   * Add given PEM to Nexus truststore.
   * @param pem The certificate to add, in PEM format.
   */
  addCertificate : function(pem) {
    var self = this, loadmask = new Ext.LoadMask(self.getEl(), {
      msg:'Adding certificate',
      removeMask : true
    });

    Ext.Ajax.request({
      url : Sonatype.config.contextPath + '/service/siesta/ssl/truststore',
      defaultErrorMessage : 'Could not add certificate.',
      jsonData : {
        value : pem
      },
      callback : function() {
        loadmask.hide();
      },
      success : function() {
        self.close();
        Nexus.ssl.CertificateStore.reload();
      }
    });
  }

});