/*
 * Copyright (c) 2008-2014 Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global NX, Ext, Nexus*/

/**
 * HACK: Exists only to prevent exceptions when {@link #loadComplete()} is invoked after node already destroyed.
 *
 * @since staging 2.3
 */
NX.define('Nexus.staging.repository.activity.AsyncNodeSupport', {
    extend: 'Ext.tree.AsyncTreeNode',

    mixins: [
        'Nexus.LogAwareMixin'
    ],

    /**
     * @constructor
     */
    constructor: function (config) {
        var self = this,
            config = config || {};

        self.constructor.superclass.constructor.call(self, config);
    },

    /**
     * @override
     * @private
     */
    loadComplete: function (deep, anim, callback, scope) {
        // HACK: Only attempt to call loadComplete if we haven't been destroyed
        if (!this.ui) {
            this.logWarn('Aborting loadComplete callback; node destroyed:', this);
            return;
        }
        //this.constructor.superclass.loadComplete.apply(this, arguments);
        Nexus.staging.repository.activity.AsyncNodeSupport.superclass.loadComplete.apply(this, arguments);
    }
});