/*
 * Copyright (c) 2008-2014 Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
define('Sonatype/repoServer/XMLPopupViewer', function() {

  Sonatype.repoServer.XMLPopupViewer = function(config) {
    var config = config || {};
    var defaultConfig = {
      title : 'XML Viewer'
    };
    Ext.apply(this, config, defaultConfig);

    Ext.Ajax.request({
          callback : this.renderXML,
          scope : this,
          method : 'GET',
          url : this.xmlUrl
        });

    Sonatype.repoServer.XMLPopupViewer.superclass.constructor.call(this, {
          closable : true,
          width : 800,
          height : 600,
          modal : true,
          resizable : true,
          draggable : false,
          items : [{
                xtype : 'form',
                layoutConfig : {
                  labelSeparator : ''
                },
                height : 600,
                frame : true,
                items : [{
                      xtype : 'textarea',
                      id : 'xml-text',
                      name : 'source',
                      hideLabel : true,
                      anchor : '100% 95%',
                      readOnly : true
                    }]
              }]
        });

    this.xmlTextArea = this.findById('xml-text');

  };

  Ext.extend(Sonatype.repoServer.XMLPopupViewer, Ext.Window, {

        renderXML : function(options, success, response) {
          if (success)
          {
            this.xmlTextArea.setRawValue(response.responseText);
          }
          else
          {
            Sonatype.utils.connectionError(response, 'The file failed to load from the server.')
          }
        }

      });

});